use std::mem::size_of;

use zerocopy::{FromBytes, LayoutVerified};

use crate::{FilePointer, FileRange};

pub trait ReaderTrait {
    fn read_raw(&self, ptr: FileRange) -> &[u8];
    fn read<T: FromBytes>(&self, ptr: FilePointer) -> &T {
        LayoutVerified::<_, T>::new(self.read_raw(ptr.range(size_of::<T>() as u64)))
            .unwrap()
            .into_ref()
    }
}
